# coding: utf-8

"""
    ****************************************************************************
    Copyright (c) 2016-present,
    Jaguar0625, gimre, BloodyRookie, Tech Bureau, Corp. All rights reserved.

    This file is part of Catapult.

    Catapult is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Catapult is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Catapult. If not, see <http://www.gnu.org/licenses/>.
    ****************************************************************************
    
    Catapult REST Endpoints
    OpenAPI Specification of catapult-rest 1.1.2  # noqa: E501
    The version of the OpenAPI document: 0.9.3
    Contact: contact@nem.foundation

    NOTE: This file is auto generated by Symbol OpenAPI Generator:
    https://github.com/nemtech/symbol-openapi-generator
    Do not edit this file manually.
"""


import pprint
import re  # noqa: F401

import six

from symbol_openapi_client.configuration import Configuration


class AggregateTransactionBodyExtendedDTO(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'transactions_hash': 'str',
        'cosignatures': 'list[CosignatureDTO]',
        'transactions': 'list[EmbeddedTransactionInfoDTO]'
    }

    attribute_map = {
        'transactions_hash': 'transactionsHash',
        'cosignatures': 'cosignatures',
        'transactions': 'transactions'
    }

    def __init__(self, transactions_hash=None, cosignatures=None, transactions=None, local_vars_configuration=None):  # noqa: E501
        """AggregateTransactionBodyExtendedDTO - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._transactions_hash = None
        self._cosignatures = None
        self._transactions = None
        self.discriminator = None

        self.transactions_hash = transactions_hash
        self.cosignatures = cosignatures
        self.transactions = transactions

    @property
    def transactions_hash(self):
        """Gets the transactions_hash of this AggregateTransactionBodyExtendedDTO.  # noqa: E501


        :return: The transactions_hash of this AggregateTransactionBodyExtendedDTO.  # noqa: E501
        :rtype: str
        """
        return self._transactions_hash

    @transactions_hash.setter
    def transactions_hash(self, transactions_hash):
        """Sets the transactions_hash of this AggregateTransactionBodyExtendedDTO.


        :param transactions_hash: The transactions_hash of this AggregateTransactionBodyExtendedDTO.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and transactions_hash is None:  # noqa: E501
            raise ValueError("Invalid value for `transactions_hash`, must not be `None`")  # noqa: E501

        self._transactions_hash = transactions_hash

    @property
    def cosignatures(self):
        """Gets the cosignatures of this AggregateTransactionBodyExtendedDTO.  # noqa: E501

        Array of transaction cosignatures.  # noqa: E501

        :return: The cosignatures of this AggregateTransactionBodyExtendedDTO.  # noqa: E501
        :rtype: list[CosignatureDTO]
        """
        return self._cosignatures

    @cosignatures.setter
    def cosignatures(self, cosignatures):
        """Sets the cosignatures of this AggregateTransactionBodyExtendedDTO.

        Array of transaction cosignatures.  # noqa: E501

        :param cosignatures: The cosignatures of this AggregateTransactionBodyExtendedDTO.  # noqa: E501
        :type: list[CosignatureDTO]
        """
        if self.local_vars_configuration.client_side_validation and cosignatures is None:  # noqa: E501
            raise ValueError("Invalid value for `cosignatures`, must not be `None`")  # noqa: E501

        self._cosignatures = cosignatures

    @property
    def transactions(self):
        """Gets the transactions of this AggregateTransactionBodyExtendedDTO.  # noqa: E501

        Array of transactions initiated by different accounts.  # noqa: E501

        :return: The transactions of this AggregateTransactionBodyExtendedDTO.  # noqa: E501
        :rtype: list[EmbeddedTransactionInfoDTO]
        """
        return self._transactions

    @transactions.setter
    def transactions(self, transactions):
        """Sets the transactions of this AggregateTransactionBodyExtendedDTO.

        Array of transactions initiated by different accounts.  # noqa: E501

        :param transactions: The transactions of this AggregateTransactionBodyExtendedDTO.  # noqa: E501
        :type: list[EmbeddedTransactionInfoDTO]
        """
        if self.local_vars_configuration.client_side_validation and transactions is None:  # noqa: E501
            raise ValueError("Invalid value for `transactions`, must not be `None`")  # noqa: E501

        self._transactions = transactions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AggregateTransactionBodyExtendedDTO):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AggregateTransactionBodyExtendedDTO):
            return True

        return self.to_dict() != other.to_dict()
